#include "mysystypes.h" 
#include "myio.h"

char (* putchar)(char);
char (* getchar)(void);

/*__flash */INT8U hex_chars[16] =
{
	'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'
};

INT8U WriteHex(INT8U c)
{
	putchar(hex_chars[c >> 4]);
	putchar(hex_chars[c & 0x0F]);
	return(c);
}

INT8U WriteINT8U(INT8U c)
{
	INT8U i;
	INT8U k = 100, IsDigitShow = 0;
	
	if(c == 0)
	{
		putchar(' ');
		putchar(' ');
		putchar('0');
	}
	else
	{
		do
		{
			i = 0;
			while(c >= k)
			{
				c -= k;
				i ++;
			}
			if ((i != 0) || IsDigitShow)
			{
				putchar('0' + i);
				IsDigitShow = 0xFF;
			}
			else
			{
				putchar(' ');
			};
		}
		while(k /= 10);
	}
	return(c);
}

void WriteINT16U_(INT16U c, INT16U k, INT8U digcount)
{
	INT8U i;
	INT8U IsDigitShow = 0;
	
	if(digcount)
		IsDigitShow =	0xFF;
	do
	{
		i = 0;
		while(c >= k)
		{
			c -= k;
			i ++;
		}
		if ((i != 0) || IsDigitShow)
		{
			putchar('0' + i);
			IsDigitShow = 0xFF;
		};
	}while((k /= 10) && (-- digcount));
	if (IsDigitShow == 0)
		putchar('0');
}

INT8S WriteINT8S(INT8S c)
{
	if (c < 0)
	{
		putchar('-');
		c = -c;
	};
	WriteINT8U(c);
	return(c);
}

void WriteINT16S(INT16S c)
{
	if (c < 0)
	{
		putchar('-');
		c = -c;
	};
	WriteINT16U(c);
}

void WriteFIX(INT16S c, INT8U dv) 
{
	if (c < 0)
	{
		putchar('-');
		c = -c;
	};
	WriteINT16U(c / dv);
	putchar('.');
	WriteINT16U_(c % dv, 10, 1);
}

char *WriteStr(char *s)
{
	while((*s) != 0)
		putchar(*(s ++));
	return(s);
}

